#ifndef MACCATEGORYELEMENTWIDGET_H
#define MACCATEGORYELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

namespace Ui
{
class MacCategoryElementWidget;
}

class IntIntervalModel;
class IntSortFilterProxyModel;

class GMCMISCELLANEOUSSESHARED_EXPORT MacCategoryElementWidget : public ViewEditElementWidget
{

    Q_OBJECT

public:

    MacCategoryElementWidget( Element * /*rootElement*/
                            , Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & )
                            , QWidget * /*parent*/ = nullptr );
    virtual ~MacCategoryElementWidget();

    void beforeCreation() override;
    ElementData * exportElementData() const override;
    void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ ) override;

    QString caption() const override;

protected:

    void reset() override;
    bool isContentValid() const override;
    void blockEditWidget( bool /*blocked*/ ) override;

protected slots:

    void setCategoryLabel( int /*index*/ );

private:

    Ui::MacCategoryElementWidget *_ui;

    Element *_rootElement;
    IntIntervalModel *_intervalModel;
    IntSortFilterProxyModel *_intSortFilterProxyModel;

};

#endif // MACCATEGORYELEMENTWIDGET_H
