#ifndef MACILEVELELEMENTWIDGET_H
#define MACILEVELELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

namespace Ui
{
class MacIlevelElementWidget;
}

class IntIntervalModel;
class IntSortFilterProxyModel;

class GMCMISCELLANEOUSSESHARED_EXPORT MacILevelElementWidget : public ViewEditElementWidget
{

    Q_OBJECT

public:

    MacILevelElementWidget( Element * /*rootElement*/
                          , Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & )
                          , QWidget * /*parent*/ = nullptr );
    virtual ~MacILevelElementWidget();

    void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ ) override;
    ElementData * exportElementData() const override;

    QString caption() const override;

protected:

    void reset() override;
    bool isContentValid() const override;
    void blockEditWidget( bool /*blocked*/ ) override;

private:

    Ui::MacIlevelElementWidget *_ui;

    Element *_rootElement;
    IntIntervalModel *_intervalModel;
    IntSortFilterProxyModel *_intSortFilterProxyModel;

};

#endif // MACILEVELELEMENTWIDGET_H
