#ifndef MACLEVELELEMENTWIDGET_H
#define MACLEVELELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

namespace Ui
{
class MacLevelElementWidget;
}

class IntIntervalModel;
class IntSortFilterProxyModel;

class GMCMISCELLANEOUSSESHARED_EXPORT MacLevelElementWidget : public ViewEditElementWidget
{

    Q_OBJECT

public:

    MacLevelElementWidget( Element * /*rootElement*/
                         , Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & )
                         , QWidget * /*parent*/ = nullptr );
    virtual ~MacLevelElementWidget();

    void beforeCreation() override;
    ElementData * exportElementData() const override;
    void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ ) override;

    QString caption() const override;

protected:

    void reset() override;
    bool isContentValid() const override;
    void blockEditWidget( bool /*blocked*/ ) override;

private:

    Ui::MacLevelElementWidget *_ui;
    Element *_rootElement;
    IntIntervalModel *_intervalModel;
    IntSortFilterProxyModel *_intSortFilterProxyModel;

};

#endif // MACLEVELELEMENTWIDGET_H
