#ifndef MISCELLANEOUSCOMMONSE_H
#define MISCELLANEOUSCOMMONSE_H

#include "gmc-miscellaneousse_global.h"

#ifndef PROCESS_AUDIT_INFO_FILE
#define PROCESS_AUDIT_INFO_FILE "/parsecfs/ps-audit-info"
#endif

#ifndef FILE_AUDIT_INFO_FILE
#define FILE_AUDIT_INFO_FILE "/parsecfs/fs-audit-info"
#endif

#include <QCoreApplication>
#include <QChar>
#include <QString>
#include <QList>

class TreeNode;
class AuditComponentRootTreeNode;

//******************************************************************************

GMCMISCELLANEOUSSESHARED_EXPORT QString fileModeToString( int /*mode*/ );

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MLog
{

public:

    enum MLogLogType{ UserAudLog = 0x00000063
                    , UserCapsLog = 0x00000073
                    , UserMacLog = 0x00000083
                    , UserMicLog = 0x00000093
                    , UdevRuleLog = 0x000000a3
                    , UdevDeviceLog = 0x000000b3 };

    static MLog *instance();
    ~MLog();

    bool writeUserLog( MLogLogType /*type*/
                     , bool /*result*/
                     , const QString & /*userName*/
                     , const QString & /*parameters*/
                     , const QString & /*comment*/ );

protected:

    MLog();

protected:

    static MLog *_instance;
    bool _isInit;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT Audit
{

    Q_DECLARE_TR_FUNCTIONS(Audit)

public:

    Audit( const QString &path );
    ~Audit();

    QString auditToString( qulonglong ) const;

    AuditComponentRootTreeNode *auditRootNode() const;

protected:
    static QMap< QString, QString > _auditTranslates;
    class AuditComponentRootTreeNode *_auditRootNode;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT ProcessAudit : public Audit
{

public:

    static ProcessAudit *instance();
    ~ProcessAudit();

protected:

    ProcessAudit();

protected:

    static ProcessAudit *_instance;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT FileAudit : public Audit
{

public:

    static FileAudit *instance();
    ~FileAudit();

protected:

    FileAudit();

protected:

    static FileAudit *_instance;

};

//******************************************************************************


#endif // MISCELLANEOUSCOMMONSE_H
