#ifndef MISCELLANEOUSELEMENT_H
#define MISCELLANEOUSELEMENT_H

#include "gmc-miscellaneousse_global.h"

#include <element.h>

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacCategoriesElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { DigitColumn = ElementRootTreeNode::_CountColumns
                            , SynonymColumn
                            , _CountColumns };

    MacCategoriesElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacCategoriesElement();

    int columnCount() const override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const override;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacLevelsElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { LevelColumn = ElementRootTreeNode::_CountColumns
                            , SynonymColumn
                            , _CountColumns };

    MacLevelsElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacLevelsElement();

    int columnCount() const override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const override;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacILevelsElement : public MacLevelsElement
{

    Q_OBJECT

public:

    MacILevelsElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacILevelsElement();

//TODO REMOVE THIS
    qulonglong availableOperations() const override;
//TODO REMOVE THIS
    void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = nullptr
                                 , int /*depth*/ = 0 ) override;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacCategoryElement : public OrdinaryElement
{

    Q_OBJECT

public:

    MacCategoryElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacCategoryElement();

    qulonglong availableOperations() const override;

    QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const override;

    QString caption() const override;
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacLevelElement : public OrdinaryElement
{

    Q_OBJECT

public:

    MacLevelElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacLevelElement();

    qulonglong availableOperations() const override;

    QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const override;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT MacILevelElement : public MacLevelElement
{

    Q_OBJECT

public:

    MacILevelElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~MacILevelElement();

//TODO REMOVE THIS
    qulonglong availableOperations() const override;
//TODO REMOVE THIS
    void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = nullptr
                                 , int /*depth*/ = 0 ) override;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT DefaultAuditElement : public OrdinaryElement
{

    Q_OBJECT

public:

    DefaultAuditElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~DefaultAuditElement();

    qulonglong availableOperations() const override;
    void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = nullptr
                                 , int /*depth*/ = 0 ) override;
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT AuditObjectsElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { NameColumn = ElementRootTreeNode::_CountColumns
                            , SuccessColumn
                            , FailColumn
                            , _CountColumns };

    AuditObjectsElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~AuditObjectsElement();

    qulonglong availableOperations() const override;
    void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = nullptr
                                 , int /*depth*/ = 0 ) override;

    int columnCount() const override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const override;
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT AuditUsersElement : public AuditObjectsElement
{

    Q_OBJECT

public:

    AuditUsersElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~AuditUsersElement();

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT AuditGroupsElement : public AuditObjectsElement
{

    Q_OBJECT

public:

    AuditGroupsElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~AuditGroupsElement();

};

//******************************************************************************

//public:
class GMCMISCELLANEOUSSESHARED_EXPORT AuditObjectElement : public OrdinaryElement
{

    Q_OBJECT

public:

    AuditObjectElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~AuditObjectElement();

    qulonglong availableOperations() const override;
    void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = nullptr
                                 , int /*depth*/ = 0 ) override;
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT CapabilitiesUsersElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { NameColumn = ElementRootTreeNode::_CountColumns
                            , LinuxCapabilitiesColumn
                            , ParsecCapabilitiesColumn
                            , _CountColumns };

    CapabilitiesUsersElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~CapabilitiesUsersElement();

    qulonglong availableOperations() const override;
    void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = nullptr
                                 , int /*depth*/ = 0 ) override;

    int columnCount() const override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const override;
};

//******************************************************************************

//public:
class GMCMISCELLANEOUSSESHARED_EXPORT CapabilitiesObjectElement : public OrdinaryElement
{

    Q_OBJECT

public:

    CapabilitiesObjectElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~CapabilitiesObjectElement();

    qulonglong availableOperations() const override;
    void performOperation( OperationType /*operation*/
                                 , ElementData * /*elementData*/ = nullptr
                                 , int /*depth*/ = 0) override;

    QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const override;
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT DeviceDevicesElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { NameColumn = ElementRootTreeNode::_CountColumns
                            , UserColumn
                            , GroupColumn
                            , ModeColumn
                            , EnabledColumn
                            , _CountColumns };

    DeviceDevicesElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~DeviceDevicesElement();

    int columnCount() const override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const override;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT DeviceRulesElement : public ContainerElement
{

    Q_OBJECT

public:

    enum ElementColumnsType { NameColumn = ElementRootTreeNode::_CountColumns
                            , EnabledColumn
                            , _CountColumns };

    DeviceRulesElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~DeviceRulesElement();

    int columnCount() const override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const override;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT DeviceDeviceElement : public OrdinaryElement
{

    Q_OBJECT

public:

    DeviceDeviceElement( Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~DeviceDeviceElement();

    QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const override;

};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT DeviceRuleElement : public OrdinaryElement
{

    Q_OBJECT

public:

    DeviceRuleElement( Module & /*module*/
                     , bool ( * /*isEditable*/ )( const Module & ) );
    virtual ~DeviceRuleElement();

    QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const override;

};

#endif // MISCELLANEOUSELEMENT_H
