#ifndef MISCELLANEOUSRECORDSE_H
#define MISCELLANEOUSRECORDSE_H

#include "gmc-miscellaneousse_global.h"

#include <record.h>

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT ExpressionRecord : public Record
{

public:

    enum TermType{ TypeTermType
                 , KeyTermType
                 , OperatorTermType
                 , ValueTermType
                 , _CountTermTypes };

    enum RecordType { DevpathRecordType
                    , NameRecordType
                    , SymlinkRecordType
                    , EnvRecordType
                    , KernelRecordType
                    , SubsystemRecordType
                    , DriverRecordType
                    , AttrRecordType
                    , TagRecordType
                    , KernelsRecordType
                    , SubsystemsRecordType
                    , DriversRecordType
                    , AttrsRecordType
                    , TagsRecordType
                    , _CountRecordTypes };

    enum OperatorType { EqualOperatorType
                      , NotEqualOperatorType
                      , _CountOperatorTypes };

    static QString recordTypeName( ExpressionRecord::RecordType /*type*/ );
    static QString recordOperatorName( ExpressionRecord::OperatorType /*type*/ );

    static int termCount();
    static QVariant termHeader( int /*term*/ );
    static Record *createRecord();

    static ExpressionRecord *fromString( const QString & /*str*/ );

    ExpressionRecord();
    ExpressionRecord( const ExpressionRecord & /*record*/ );
    virtual ~ExpressionRecord();

    const ExpressionRecord &operator=( const ExpressionRecord & /*record*/ );

    bool isEmpty() const override;
    bool isValid() const override;
    bool isEditable( int /*term*/ ) const override;
    QString toString() const;

    QVariant data( int /*term*/, int /*role*/ ) const override;
    bool setData( int /*term*/, const QVariant & /*value*/ ) override;

    ExpressionRecord::RecordType recordType() const;
    void setRecordType(const ExpressionRecord::RecordType & /*recordType*/ );

    const QString & key() const;
    void setKey(const QString & /*key*/ );

    const QString & value() const;
    void setValue(const QString & /*value*/ );

    OperatorType operatorType() const;
    void setOperatorType(const OperatorType & /*operatorType*/ );

protected:

    ExpressionRecord::RecordType _recordType;
    OperatorType _operatorType;
    QString _key;
    QString _value;

};

#endif // MISCELLANEOUSRECORDSE_H
