#ifndef MISCELLANEOUSTREENODESE_H
#define MISCELLANEOUSTREENODESE_H

#include "gmc-miscellaneousse_global.h"

#include <treenode.h>

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT AuditComponentRootTreeNode : public TreeNode
{

    Q_OBJECT

public:

    enum AuditComponentColumnsType { DigitColumn
                                   , SignatureColumn
                                   , NameColumn
                                   , _CountColumns };

    AuditComponentRootTreeNode( QObject * /*parent*/ = nullptr );
    virtual ~AuditComponentRootTreeNode();

    int columnCount() const override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const override;
};

//******************************************************************************

class GMCMISCELLANEOUSSESHARED_EXPORT AuditComponentTreeNode : public TreeNode
{

    Q_OBJECT

public:

    AuditComponentTreeNode( const QString & /*name*/
                          , const QString & /*description*/
                          , QChar /*sign*/
                          , int /*digit*/
                          , QObject * /*parent*/ = nullptr );
    virtual ~AuditComponentTreeNode();

    QVariant data( int /*column*/, int /*role*/ = Qt::DisplayRole ) const override;

    int digit() const;
    const QChar &sign() const;

protected:

    QString _name;
    QString _description;
    QChar _sign;
    int _digit;

};

//******************************************************************************

#endif
