#ifndef OBJECTAUDITELEMENTWIDGET_H
#define OBJECTAUDITELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

class QSortFilterProxyModel;

class AuditComponentRootTreeNode;
class AuditTwoCheckTreeNodeModel;

namespace Ui
{
class ObjectAuditElementWidget;
}

class GMCMISCELLANEOUSSESHARED_EXPORT ObjectAuditElementWidget : public ViewEditElementWidget
{
    Q_OBJECT

public:

    ObjectAuditElementWidget( Element * /*defaultAuditElement*/
                            , Module & /*module*/
                , bool ( * /*isEditable*/ )( const Module & )
                            , QWidget * /*parent*/ = nullptr );
    virtual ~ObjectAuditElementWidget();

    void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ ) override;
    ElementData *exportElementData() const override;

    QString caption() const override;

protected:

    void loadSettings();
    void saveSettings() const;

    void reset() override;
    void blockEditWidget( bool /*blocked*/ ) override;

    virtual QString auditToString( qulonglong ) const = 0;

protected slots:

    void auditDefaultResest( int state );
    void auditChanged();

protected:

    Ui::ObjectAuditElementWidget *_ui;

    Element *_defaultAuditElement;

    AuditTwoCheckTreeNodeModel *_auditTreeNodeModel;
    QSortFilterProxyModel *_sortFilterProxyModel;

};

#endif // OBJECTAUDITELEMENTWIDGET_H
