#ifndef RULEELEMENTWIDGET_H
#define RULEELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

#include "ruledeviceserviceexpressions.h"

class QValidator;

namespace Ui
{
class RuleElementWidget;
}

class GMCMISCELLANEOUSSESHARED_EXPORT RuleElementWidget
: public ViewEditElementWidget
, public RuleDeviceExpressionsServiceClass
{

    Q_OBJECT

public:

    RuleElementWidget( Module & /*module*/
                     , bool ( * /*isEditable*/ )( const Module & ), QWidget * /*parent*/ = nullptr );
    virtual ~RuleElementWidget();

    void init();

    void beforeCreation() override;
    ElementData * exportElementData() const override;
    void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ ) override;

    QString caption() const override;

protected:

    void reset() override;
    bool isContentValid() const override;
    void blockEditWidget( bool /*blocked*/ ) override;

protected slots:

    void importRecordData();
    void descriptionChanged();

protected:

    Ui::RuleElementWidget *_ui;
    int _descriptionMaxSize;
    QValidator *_nameValidator;

};

#endif // RULEELEMENTWIDGET_H
