#ifndef USERMACELEMENTWIDGET_H
#define USERMACELEMENTWIDGET_H

#include "gmc-miscellaneousse_global.h"

#include <elementwidget.h>

namespace Ui
{
class UserMacElementWidget;
}

class TreeNode;
class MacCategoriesTwoCheckTreeNodeModel;
class MacLevelProxyModel;
class ElementsWidgetProxyModel;

class GMCMISCELLANEOUSSESHARED_EXPORT UserMacElementWidget : public ViewEditElementWidget
{
    Q_OBJECT

public:

    enum WidgetMode { LocalMode
                    , AldMode
                    , _CountModes };

    UserMacElementWidget( Module & /*module*/
                        , bool ( * /*isEditable*/ )( const Module & )
                        , UserMacElementWidget::WidgetMode /*widgetMode*/
                        , QWidget * /*parent*/ = nullptr );
    virtual ~UserMacElementWidget();

    ElementData * exportElementData() const override;
    void afterSuccessfulRead( Element * /*testElement*/, ElementData * /*elementData*/ ) override;
    bool hasAnotherHighMicAdmin();

protected:

    void loadSettings();
    void saveSettings() const;

    void reset() override;
    bool isContentValid() const override;
    void blockEditWidget( bool /*blocked*/ ) override;

protected slots:

    void iLevelMinChanged( int /*index*/ );
    void iLevelMaxChanged( int /*index*/ );
    void levelMinChanged( int /*index*/ );
    void levelMaxChanged( int /*index*/ );

protected:

    Ui::UserMacElementWidget *_ui;

    TreeNode *_categoriesRootNode;
    TreeNode *_iLevelsRootNode;
    TreeNode *_levelsRootNode;

    MacCategoriesTwoCheckTreeNodeModel *_categoriesModel;
    ElementModel *_iLevelsModel;
    ElementModel *_levelsModel;

    ElementsWidgetProxyModel *_categoriesProxyModel;
    MacLevelProxyModel *_minILevProxyModel;
    MacLevelProxyModel *_maxILevProxyModel;
    MacLevelProxyModel *_minLevProxyModel;
    MacLevelProxyModel *_maxLevProxyModel;

};

#endif // USERMACELEMENTWIDGET_H
